/**
 * Open SUIT - Simple User Interface Toolkit
 * 
 * Copyright (c) 2009 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.ow2.opensuit.samples.livetour.model.to;

import java.io.Serializable;
import java.util.Date;

public class BookTO implements Cloneable, Serializable
{
	private static final long serialVersionUID = 1L;

	private int id;
	private String title;
	private String author;
	private String[] languages;
	private Date editionDate;
	private float copies;
	
	public BookTO clone() throws CloneNotSupportedException
	{
		//try
        //{
	    return (BookTO)super.clone();
        //}
        //catch(CloneNotSupportedException e)
        //{
	    //    e.printStackTrace();
	    //    return null;
        //}
	}

	public int getId()
	{
		return id;
	}
	public void setId(int id)
	{
		this.id = id;
	}
	public String getTitle()
	{
		return title;
	}
	public void setTitle(String title)
	{
		this.title = title;
	}
	public String getAuthor()
	{
		return author;
	}
	public void setAuthor(String author)
	{
		this.author = author;
	}
	public Date getEditionDate()
	{
		return editionDate;
	}
	public void setEditionDate(Date editionDate)
	{
		this.editionDate = editionDate;
	}
	public float getCopies()
	{
		return copies;
	}
	public void setCopies(float copies)
	{
		this.copies = copies;
	}
	public String[] getLanguages()
	{
		return languages;
	}
	public void setLanguages(String[] languages)
	{
		if(languages != null){
			this.languages = languages.clone();
		}
	}
	@Override
	public String toString()
	{
		return "Book '"+title+"' from "+author+" first printed "+(1900+editionDate.getYear())+": "+copies+" million copies.";
	}
	
}
