package org.ow2.opensuit.samples.livetour.uibeans;

import java.io.Serializable;

import javax.servlet.http.HttpServletRequest;

public class ChartBean implements Serializable
{
	private static final long serialVersionUID = 1L;
	
	private static long time;
	
	private static int[] years= { 
		1900,
		1910,
		1920,
		1930,
		1940,
		1950,
		1960,
		1970,
		1980,
		1990,
		2000,
	};
	private static int[] countries = { 0, 1, 2 };
	private static String[] countryNames = { "France", "United States", "England" };
	private static int[][] population = { 
		{ // France
			// 1900
			40681000,
			// 1910
			41350000,
			// 1920
			38900000,
			// 1930
			41340000,
			// 1940
			40690000,
			// 1950
			41647258,
			// 1960
			45464797,
			// 1970
			50528219,
			// 1980
			53731387,
			// 1990
			56577000,
			// 2000
			58858000 },
		{ // United States
			// 1900
			76212168,
			// 1910
			92228496,
			// 1920
			106021537,
			// 1930
			123202624,
			// 1940
			132164569,
			// 1950
			151325798,
			// 1960
			179323175,
			// 1970
			203211926,
			// 1980
			226545805,
			// 1990
			248709873,
			// 2000
			281421906 },
		{ // England
			// 1901
			30515000,
			// 1911
			33651600,
			// 1921
			35230200,
			// 1931
			37359000,
			// 1940 ???
			39000000,
			// 1951
			41042200,
			// 1961
			43983300,
			// 1971
			45870100,
			// 1981
			46623500,
			// 1991
			48067300,
			// 2001
			49138831
		}
	};
	private int[] cities = {
			0, 1, 2, 3, 4, 5, 6, 7, 8, 9
	};
	private String[] cityNames = {
			"New York",
			"Los Angeles",
			"Chicago",
			"Dallas",
			"Philadelphia",
			"Houston",
			"Miami",
			"Atlanta",
			"Washington",
			"Boston"
	};
	private int[] cities_population = {
			19006798,
			12872808,
			9569624,
			6300006 ,
			5838471,
			5728143,
			5414772,
			5376285,
			5358130,
			4522858
	};
	private int[] selectedCountries = countries;

	public void load(HttpServletRequest request) {
		update();
	}
	public void update()
	{
		time = System.currentTimeMillis();
	}
	public static long getTime() {
		return time;
	}
	public static int[] getAllCountries() {
		return countries;
	}
	public static String getCountryName(int country) {
		return countryNames[country];
	}
	public static int[] getYears() {
		return years;
	}
	public static int getPopulation(int country, int year) {
		return population[country][(year-1900)/10];
	}
	public int[] getSelectedCountries() {
		return selectedCountries;
	}
	public void setSelectedCountries(int[] selectedCountries) {
		if(selectedCountries != null){
			this.selectedCountries = selectedCountries.clone();
		}
	}
	public int[] getCities() {
		return cities;
	}
	public String getCityName(int city) {
		return cityNames[city];
	}
	public int getCityPopulation(int city) {
		return cities_population[city];
	}

}
