/**
 * Open SUIT - Simple User Interface Toolkit
 * 
 * Copyright (c) 2009 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.ow2.opensuit.samples.livetour.uibeans;

import java.io.File;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class FilesBean implements Serializable
{
	private static final long serialVersionUID = 1L;
	
	private static final File[] FILES_ARRAY_TYPE = {};
	public File[] getRootFiles()
	{
		List<File> roots = new ArrayList<File>();
		File[] files = File.listRoots();
//		System.out.println(""+files.length+" roots:");
		for(int i=0; i<files.length; i++)
		{
			// --- remove floppy drives as this causes a stupid bug
			if(!files[i].getPath().startsWith("A:")){
				roots.add(files[i]);
			}
			
//			System.out.println(" -"+i+": "+files[i].getName()+" --> "+files[i]);
		}
//		System.out.println("... ok");
		return roots.toArray(FILES_ARRAY_TYPE);
	}
	public String getName(File iFile)
	{
		if(iFile.getName() == null || iFile.getName().length() == 0)
		{
			String name = iFile.getPath();
			int idx = name.indexOf(File.separator);
//			System.out.println("about to return "+iFile+" path...");
			return idx >= 0 ? name.substring(0, idx) : name;
		}
		return iFile.getName();
	}
	public String getType(File iFile)
	{
//		System.out.println("about to evaluate "+iFile+" type...");
		if(iFile.isDirectory()){
			return "folder";
		}
		
		String extension = iFile.getName();
		int idx = extension.lastIndexOf('.');
		
		if(idx >= 0){
			extension = extension.substring(idx+1);
		} else{
			return "generic";
		}
		
		//  TODO: manage types
		
		return "generic";
	}
	public File getFile(String path)
	{
		return new File(path);
	}
}
