/**
 * Open SUIT - Simple User Interface Toolkit
 * 
 * Copyright (c) 2009 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.ow2.opensuit.samples.livetour.uibeans;

import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import org.ow2.opensuit.core.impl.multiparts.IFileUploadPart;


public class GenericFormBean implements Serializable
{
	private static final long serialVersionUID = 1L;
	
	private boolean check1;
	private Date date1;
	private int int1;
	private int[] multi1;
	private Animal choice1 = Animal.cat;
	private String text1;
	private String file1;
	private int filesize1;
	
	private boolean check2;
	private Date date2;
	private int int2;
	private int[] multi2;
	private Animal choice2 = Animal.dog;
	private String text2;
	private String file2;
	private int filesize2;
	
	private boolean check3;
	private Animal choice3 = Animal.frog;
	private Date date3;
	private String text3;
	
	 private List<String> multiChoiceSelection;
	 private List<TreeLeaf> root;
	    
	public GenericFormBean()
	{
		reset();
	}
	public void load()
	{
	}
	public void reload()
	{
	}
	public void reset()
	{
		check1 = true;
		check2 = true;
		text1 = "text 1 initial value";
		text2 = "text 2 initial value";
		text3 = "text 3 initial value";
		file1 = "file1.txt";
		file2 = "file2.txt";
		Calendar cal = Calendar.getInstance();
		date1 = cal.getTime();
		date2 = cal.getTime();
		date3 = cal.getTime();
		initMultiChoiceTreeField();
	}
	public static void main(String[] args){
		System.out.println("1: "+Animal.cat);
		System.out.println("2: "+Animal.dog);
	}
	public void onFile1(IFileUploadPart file) throws IOException
	{
		System.out.println("--> file 1: "+file);
		byte[] buffer = new byte[512];
		filesize1 = 0;
		int read = 0;
		
		while((read = file.getFileInputStream().read(buffer)) > 0){
			filesize1 += read;
		}
		
		System.out.println("bytes read: "+filesize1);
	}
	public void onFile2(IFileUploadPart file) throws IOException
	{
		System.out.println("--> file 2: "+file);
		byte[] buffer = new byte[512];
		filesize2 = 0;
		int read = 0;
		
		while((read = file.getFileInputStream().read(buffer)) > 0){
			filesize2 += read;
		}
		
		System.out.println("bytes read: "+filesize2);
	}
	public int[] getItems(int nb)
	{
		int[] items = new int[nb];
		
		for(int i=0; i<nb; i++){
			items[i] = i;
		}
		
		return items;
	}
	public Animal[] getAnimals()
	{
		return Animal.values();
	}

	public boolean isCheck1()
	{
		return check1;
	}

	public void setCheck1(boolean check1)
	{
		this.check1 = check1;
	}

	public Date getDate1()
	{
		return date1;
	}

	public void setDate1(Date date1)
	{
		this.date1 = date1;
	}

	public int getInt1()
	{
		return int1;
	}

	public void setInt1(int int1)
	{
		this.int1 = int1;
	}

	public int[] getMulti1()
	{
		return multi1;
	}

	public void setMulti1(int[] multi1)
	{
	    if(multi1 != null){
            this.multi1 = multi1.clone();
        } else {
            throw new IllegalArgumentException("Parameter: 'multi1' must not be null");
        }
	}

	public Animal getChoice1()
	{
		return choice1;
	}

	public void setChoice1(Animal choice1)
	{
		this.choice1 = choice1;
	}

	public String getText1()
	{
		return text1;
	}

	public void setText1(String text1)
	{
		this.text1 = text1;
	}

	public String getFile1()
	{
		return file1;
	}

	public void setFile1(String file1)
	{
		this.file1 = file1;
	}

	public boolean isCheck2()
	{
		return check2;
	}

	public void setCheck2(boolean check2)
	{
		this.check2 = check2;
	}

	public Date getDate2()
	{
		return date2;
	}

	public void setDate2(Date date2)
	{
		this.date2 = date2;
	}

	public int getInt2()
	{
		return int2;
	}

	public void setInt2(int int2)
	{
		this.int2 = int2;
	}

	public int[] getMulti2()
	{
		return multi2;
	}

	public void setMulti2(int[] multi2)
	{
	    if(multi2 != null){
	        this.multi2 = multi2.clone();
	    } else {
	        throw new IllegalArgumentException("Parameter: 'multi2' must not be null");
	    }
	}

	public Animal getChoice2()
	{
		return choice2;
	}

	public void setChoice2(Animal choice2)
	{
		this.choice2 = choice2;
	}

	public String getText2()
	{
		return text2;
	}

	public void setText2(String text2)
	{
		this.text2 = text2;
	}

	public String getFile2()
	{
		return file2;
	}

	public void setFile2(String file2)
	{
		this.file2 = file2;
	}

	public boolean isCheck3() {
		return check3;
	}
	public void setCheck3(boolean check3) {
		this.check3 = check3;
	}
	public Animal getChoice3()
	{
		return choice3;
	}
	public void setChoice3(Animal choice3)
	{
		this.choice3 = choice3;
	}
	public Date getDate3()
	{
		return date3;
	}
	public void setDate3(Date date3)
	{
		this.date3 = date3;
	}
	public String getText3()
	{
		return text3;
	}
	public void setText3(String text3)
	{
		this.text3 = text3;
	}
	public int getFilesize1()
	{
		return filesize1;
	}
	public int getFilesize2()
	{
		return filesize2;
	}
	
	private void initMultiChoiceTreeField(){
	 // --- init tree
        root = new ArrayList<TreeLeaf>();
        TreeNode node1 = new TreeNode("node1");
        node1.addChild(new TreeLeaf("leaf1-1", "1/1"));
        node1.addChild(new TreeLeaf("leaf1-2", "1/2"));
        node1.addChild(new TreeLeaf("leaf1-3", "1/3"));
        node1.addChild(new TreeLeaf("leaf1-4", "1/4"));
        root.add(node1);
        
        TreeNode node2 = new TreeNode("node2");
        node2.addChild(new TreeLeaf("leaf2-1", "2/1"));
        node2.addChild(new TreeLeaf("leaf2-2", "2/2"));
        TreeNode node23 = new TreeNode("node2-3");
        node23.addChild(new TreeLeaf("leaf2-3-1", "2/3/1"));
        node23.addChild(new TreeLeaf("leaf2-3-2", "2/3/2"));
        node2.addChild(node23);
        node2.addChild(new TreeLeaf("leaf2-4", "2/4"));
        root.add(node2);
        
        root.add(new TreeLeaf("leaf3", "3"));
        
        multiChoiceSelection = new ArrayList<String>();
        multiChoiceSelection.add("1/3");
        multiChoiceSelection.add("2/1");
        multiChoiceSelection.add("2/3/2");
	}
	
	public List<String> getMultiChoiceSelection() {
        return multiChoiceSelection;
    }
    public void setMultiChoiceSelection(List<String> multiChoiceSelection) {
        this.multiChoiceSelection = multiChoiceSelection;
    }
    public List<TreeLeaf> getRootItems() {
        return root;
    }
    public List<TreeLeaf> getChildren(TreeLeaf leaf) {
        return (leaf instanceof TreeNode) ? ((TreeNode)leaf).getChildren() : null;
    }
    public boolean isNode(TreeLeaf leaf) {
        return (leaf instanceof TreeNode);
    }
    
    public static class TreeLeaf
    {
        private String name;
        private String id;
        /**
         * @param name
         * @param id
         */
        public TreeLeaf(String name, String id) {
            this.name = name;
            this.id = id;
        }
        public String getName() {
            return name;
        }
        public String getId() {
            return id;
        }
    }
    public static class TreeNode extends TreeLeaf
    {
        private List<TreeLeaf> children = new ArrayList<TreeLeaf>();
        
        public TreeNode(String name) {
            super(name, null);
        }
        public List<TreeLeaf> getChildren() {
            return children;
        }
        public void addChild(TreeLeaf child)
        {
            children.add(child);
        }
    }
}
