/**
 * Open SUIT - Simple User Interface Toolkit
 * 
 * Copyright (c) 2009 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.ow2.opensuit.samples.livetour.uibeans;

import java.io.Serializable;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.ow2.opensuit.samples.livetour.model.dataaccess.BestSellersDataBase;
import org.ow2.opensuit.samples.livetour.model.dataaccess.DataBaseError;
import org.ow2.opensuit.samples.livetour.model.to.BookTO;


public class ListOfBooksBean implements Serializable
{
	private static final long serialVersionUID = 1L;
	
	private BookTO[] books;
	private List<String> allLanguages;
	private int[] selectedIds;
	
	
	public void loadAll(HttpServletRequest request) throws DataBaseError
	{
		BestSellersDataBase db = BestSellersDataBase.getDataBase();
		books = db.getAllBooks(null);
		allLanguages = db.getAllLanguages();
	}
	public BookTO[] getBooks()
	{
		return books;
	}
	public List<String> getAllLanguages()
	{
		return allLanguages;
	}
	public int[] getSelectedIds()
	{
		return selectedIds;
	}
	public void setSelectedIds(int[] selectedIds)
	{
		if(selectedIds != null){
			this.selectedIds = selectedIds.clone();
		}
	}
}
