package org.ow2.opensuit.samples.livetour.uibeans;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Random;

public class StatsBean implements Serializable
{
	private static final long serialVersionUID = 1L;
	
	private List<Stat> stats;
	private Stat total;
	
	public void load()
	{
		stats = new ArrayList<Stat>();
		int totalAmount = 0;
		Random rd = new Random();
		long now = System.currentTimeMillis();
		for(int i=0; i<100; i++)
		{
			Stat s = new Stat(
					new Date(now - rd.nextInt(365*24*60*60*1000)), // date between now and one year ago
					"entry "+i,
					rd.nextInt(1000),
					Status.values()[rd.nextInt(3)]);
			stats.add(s);
			totalAmount += s.getAmount();
		}
		total = new Stat(null, "TOTAL", totalAmount, Status.ok);
	}
	public List<Stat> getStats() {
		return stats;
	}
	public Stat getTotal() {
		return total;
	}
	public Status[] getAllStatus()
	{
		return Status.values();
	}
	public static enum Status
	{
		ok, ko, pending;
	}
	public static class Stat implements Serializable
	{
		private static final long serialVersionUID = 1L;
		
		private Date date;
		private String name;
		private int amount;
		private Status status;
		
		public Stat(Date date, String name, int amount, Status status) {
			this.date = date;
			this.name = name;
			this.amount = amount;
			this.status = status;
		}
		public int getAmount() {
			return amount;
		}
		public Date getDate() {
			return date;
		}
		public String getName() {
			return name;
		}
		public Status getStatus() {
			return status;
		}
	}
	
}
